Talented_GatherDB = Talented_GatherDB or {}
local class = select(2, UnitClass("player"))
Talented_GatherDB[class] = nil

local FillPrereqs = function (...)
	if select("#", ...) < 3 then return end
	local table = {}
	for i = 1, select("#", ...), 3 do
		local row, column = select(i, ...)
		table[#table + 1] = { row = row, column = column }
	end
	return table
end

local function GetClassTalentsInfo()
	local result = {} 
	local count = GetNumTalentTabs()
	if count == 0 then return end
	for tab = 1, GetNumTalentTabs() do
		local icon, _, background = select(2, GetTalentTabInfo(tab))
		result[tab] = {
			info = {
				icon = icon,
				background = background,
			},
			talents = {}
		}
		local talents = result[tab].talents
		for index = 1, GetNumTalents(tab) do
			local icon, row, column, _, ranks, exceptional = select(2, GetTalentInfo(tab, index))
			talents[index] = {
				info = {
					icon = icon,
					row = row,
					column = column,
					ranks = ranks,
					exceptional = exceptional,
					prereqs = FillPrereqs(GetTalentPrereqs(tab, index)),
				},
			}
		end
	end
	Talented_GatherDB[class] = result
	return true
end

local f = CreateFrame("Frame", nil, UIParent)

local time
local UpdateTalents
local function OnUpdate(frame, elapsed)
	time = time - elapsed
	if time < 0 then
		UpdateTalents()
	end
end

function UpdateTalents()
	f:SetScript("OnUpdate", nil)
	if not GetClassTalentsInfo() then
		time = 1
		f:SetScript("OnUpdate", OnUpdate)
	end
end

local function OnEvent(frame, event)
	if event == "PLAYER_LOGIN" then
		UpdateTalents()
	end
end


f:RegisterEvent("PLAYER_LOGIN")
f:SetScript("OnEvent", OnEvent)
